#!/bin/sh
C=g++
echo
echo "CXXFLAGS = -std=c++20 -fmodules-ts -g -O2 -Wall"
echo "CFLAGS = -std=c11 -g -O2 -Wall"
echo "LDLIBS = -lm -lpthread"
echo "CXX = $C"

echo
echo "############################################################"
echo "# C++ programs:"
for i in *.cc; do
        echo "PROGS += ${i%%.cc}"
done
echo
echo
echo "all: \$(PROGS)"
echo
echo "clean:"
echo "	rm -f \$(PROGS) *.o"
echo
echo "pack: clean"
echo '	(                                               \'
echo '	NAME=$$(basename $$(pwd)); cd ..;               \'
echo '	tar czvf $$NAME-$$(date -I).tar.gz ./$$NAME/    \'
echo '	)'
echo
echo "# generated by: $C -MM"
$C -MM *.cc
echo "#"

