
// basic chrono usage: clocks
// TODO: explain clocks, are they singletons?

#include <chrono>
#include <iostream>

#define PRINT(x) do {                           \
    std::cout << x << " == " #x "\n";           \
}while(0)

int main() {
    using namespace std::chrono;
    PRINT(sys_seconds{946'684'800s});
    PRINT(sys_seconds{});
    std::cout << "\n";

    utc_clock utc;              // may be instantiated?
    PRINT(utc_clock::is_steady);
    time_point ut{utc.now()};   // store current time
    std::cout << ut << " (epoch: " << time_point<utc_clock>() << ")\n";    // print
    std::cout << ut+1s << " (+1s)\n";
    std::cout << ut+1h << " (+1h)\n";
    std::cout << ut-24h << " (-24h)\n";
    std::cout << "\n";

    PRINT(tai_clock::now());    // atomic
    PRINT(utc_clock::now());    // +leap seconds
    PRINT(system_clock::now());
    PRINT(high_resolution_clock::now());
#if 0
    PRINT(steady_clock::now());
#endif

}
