
// example: copy ctr, move ctr, new, delete, copy elision
// C++17 works without copy/move ctr
// public domain

#include <iostream>

struct X {
    int data;
    X(int x=0) : data{x} { std::cout << 'I'; }
#if 1   // try value 0 with < C++17
    X(const X & x) : data{x.data} { std::cout << 'C'; }
    X(X && x) : data{std::move(x.data)} { std::cout << 'M'; }
#else
    X(const X & x) = delete;
    X(X && x) = delete;
#endif
    ~X() { std::cout << 'D'; }
};

X f(X o) {
    std::cout << " return: ";
    return o;
}

int main() {
    const int N=5;
#if 1
    X *p2 = new X[N]{X{1},X{2},X{3},}; // copy elision
#else
    X *p2 = new X[N]{1,2,3};           // copy elision
#endif
    std::cout << '\n';
    for(int i=0; i<N; ++i)
        std::cout << p2[i].data << '\n';
    delete[] p2;
    std::cout << '\n';
    X o1(111);
    std::cout << "\nf: ";
#if 1
    X o2 { f(std::move(o1)) };
#else
    X o2 { f(o1) };
#endif
    std::cout << '\n';
}
