
// simple test of "T *p = new T[n]" exception safety
// use    g++ -g thisfile.cc ; objdump -S a.out
// or     g++ -g -Wa,-adhln thisfile.cc

#include <iostream>
#include <memory>

const int MAX=3;

struct T {
    static int count;
    T() {
       if(count>=MAX) throw 1;
       ++count;
       std::cout << "T()    object count = " << count <<"\n";
    }
    ~T() {
       std::cout << "~T()\n";
        --count;
    }
};

int T::count = 0;

int main() try {
  std::cout << "=== Before init\n";
  T *ptr = new T[10];   // T() will throw
  std::cout << "=== After init\n";
  delete[] ptr;
}
catch(...) {
    std::cout << "=== Exception: object count = " << T::count << "\n";
} // end of catch

