
#include <iostream>
#include <filesystem>

#ifndef __cpp_lib_filesystem
#  error "Usage: g++ -std=c++17"
#endif
namespace fs = std::filesystem;

int main() {
    auto tmp = fs::temp_directory_path();
    std::cout << "Temp directory is " << tmp << '\n';
    auto cwd = fs::current_path();
    std::cout << "Current directory is " << cwd << '\n';
    std::cout << "is_directory(cwd) == " << is_directory(cwd) << '\n';

    fs::space_info s = fs::space(cwd);
    std::cout << "Capacity:  " << s.capacity << '\n';
    std::cout << "Free:      " << s.free << '\n';
    std::cout << "Available: " << s.available << '\n';

    std::cout << "Current directory iteration:\n";
    std::cout << "============================\n";
    int count=0;
    for(auto p: fs::directory_iterator("."))
        std::cout << std::setw(4) << ++count << " " << p << '\n';
    std::cout << "============================\n";

    fs::path p = "/foo/bar.txt";
    std::cout << p << '\n';
    std::cout << p.is_absolute() << '\n';
    std::cout << p.extension() << '\n';
    std::cout << p.has_extension() << '\n';
    std::cout << p.filename() << '\n';
    std::cout << p.stem() << '\n';
    std::cout << p.parent_path() << '\n';
}
