
// use  g++ -std=c++20

#include <chrono>
#include <format>
#include <iostream>

int main()
{
    std::chrono::time_point<std::chrono::utc_clock> epoch;

    std::cout << std::format("utc_clock epoch = {0:%F}T{0:%R%z}", epoch)
              << '\n';

    auto now1 = std::chrono::utc_clock::now();
    auto now2 = std::chrono::utc_clock::now();
    while(now1==now2) {
       now2 = std::chrono::utc_clock::now();
    }

    std::cout << std::format("utc_clock::now() = {0:%F}T{0:%R%z}", now1)
              << '\n';
    auto delta = std::chrono::duration_cast<std::chrono::nanoseconds>(now2-now1).count();
    std::cout << "utc_clock resolution <= " << delta << " ns\n";
}

