
// cppreference.com

#include <type_traits>

using ret_t = int (*)();

auto func2(char) -> ret_t {
    return nullptr;
}

int main()
{
    static_assert(std::is_invocable_v<int()>);
    static_assert(not std::is_invocable_v<int(), int>);
    static_assert(std::is_invocable_r_v<int, int()>);
    static_assert(not std::is_invocable_r_v<int*, int()>);
    static_assert(std::is_invocable_r_v<void, void(int), int>);
    static_assert(not std::is_invocable_r_v<void, void(int), void>);
    static_assert(std::is_invocable_r_v<ret_t, decltype(func2), char>);
    static_assert(not std::is_invocable_r_v<ret_t, decltype(func2), void>);
}

