
// source: cppreference

#include <iostream>
#include <tuple>
//#include <format>

std::tuple<int, int> f() // this function returns multiple values
{
    int x = 5;
#if __cplusplus >= 201703L
    return {x,7};                 // C++17
#else
    return std::make_tuple(x, 7); // C++11
#endif
}

int main()
{
    std::cout << "__cplusplus = " << __cplusplus << '\n';
    // heterogeneous tuple construction
    int n = 1;
    auto t = std::make_tuple(10, "Test", 3.14, std::ref(n), n);
    n = 7;
    std::cout << "The value of t is ("
              << std::get<0>(t) << ", "
              << std::get<1>(t) << ", "
              << std::get<2>(t) << ", "
              << std::get<3>(t) << ", "
              << std::get<4>(t) << ")\n";

    //C++23?  std::print("t = {}\n", t);
    //C++20?? std::cout << std::format("t = {}\n", t);

    // function returning multiple values
    int a, b;
    std::tie(a, b) = f();
    std::cout << "The function returned: ";
    std::cout << a << ' ' << b << '\n';
}

