
// simple function tracing in C++
// source:
// https://stackoverflow.com/questions/21863695/macro-to-print-function-entry-and-exit-trace/
#include <iostream>


#define LOG_CALL tracer_t _token(__func__)

struct tracer_t {
    char const* fname;
    tracer_t(char const* fname_): fname(fname_) {
        std::cout << "ENTER: " << (fname) << "\n";
    }
    ~tracer_t() {
        std::cout << "LEAVE: " << (fname) << "\n";
    }
};

void myfunc() { LOG_CALL;
    // test function
    std::cout << "test function\n";
}

int main() {
    myfunc();
    myfunc();
}

